/*------------------------------------------------------------
 * Typography
 *------------------------------------------------------------*/

html {
	font-family: @typo_body_font;
	font-weight: @typo_body_weight;
	font-style: @typo_body_style;
	font-size: unit(@typo_body_size, px);
	line-height: @typo_body_line;
	text-transform: @typo_body_transform;
	letter-spacing: @typo_body_letter;

	word-wrap: break-word;
	overflow-wrap: break-word;
}

body {
	color: @grey;

	/* Better Font Rendering */
	text-rendering: optimizeLegibility;
	-webkit-font-smoothing: antialiased;
	-moz-osx-font-smoothing: grayscale;

	.dark-mode { color: @grey-label; }
}

small, .small { font-size: 0.875em; /* 16px : 14px */ }
.large { font-size: 1.143em; /* 14px : 16px */ }
.font-size--reset { font-size: unit(@typo_body_size, px); }

.sidebar,
.hygge-sideblock {
	.small;
	line-height: 1.8;
}

a {
	&,
	&:active,
	&:focus {
		text-decoration: none;
		outline:none;
	}

	.transition;

	.link-color( @black, @primary-color );

	.dark-mode & {
		.link-color( @grey-light, @grey-label );
	}
}

.link--underline {
	display: inline-block;
	line-height: 1 !important;
	color: @black;

	.dark-mode & {
		color: @white;
	}

	&:after {
		content: '';
		display: block;
		height: 1px;
		background: @black;
		width: 0%;
		margin: 5px auto 0;
		opacity: 0;
		.transition;

		.dark-mode & {
			background: @white;
		}
	}

	&:hover {
		color: @black;

		.dark-mode & {
			color: @white;

			&:after {
				background: @white;
			}
		}

		&:after {
			opacity: 1;
			width: 100%;
		}
	}
}



p, pre, ul, ol,
.alignleft, .alignright,
hr, .hygge-separator--small
{
	margin-top: 0;
	margin-bottom: 1.7em;

	@media @tablet, @desktop {
		margin-bottom: 1.7em;
	}

	.hygge-sideblock &{
		margin-bottom: 1.7em;

		&:last-child {
			margin-bottom: 0;
		}
	}
}

table, .aligncenter, .alignnone,
.custom-banner, .rich-image,
.gallery:not(body)
{
	margin-bottom: 1.7em;
	margin-top: 0;

	@media @tablet, @desktop {
		margin-bottom: 2.8em;
		margin-top: 0;

		.hygge-sideblock &{
			margin-bottom: 1.7em;

			&:last-child {
				margin-bottom: 0;
			}
		}
	}
}

.editor-content .description-heading,
blockquote,
.wp-caption {
	margin-bottom: 1.7em;
	margin-top: 0;
}



.hygge-separator {
	border: none;
	height: 1px;
	background: @grey-light;
	line-height: 1;
}

hr:not(.hygge-anchor):not(.hygge-spacing) {
	.hygge-separator;

	&.sideblock-clear,
	&.cl {
		margin: 0;
		visibility: hidden;
	}
}

.hygge-separator--small {
	width: 30px;
	margin-left: 0;
	height: 3px !important;

	&[style*="right"],
	&.align-right,
	[style*="right"] + &,
	.align-right + & {
		margin-right: 0;
		margin-left: auto;
	}

	&[style*="center"],
	&.align-center,
	[style*="center"] + &,
	.align-center + & {
		margin-left: auto;
		margin-right: auto;
	}

	h1 + & { margin-top: unit(-@typo_h1_size * 0.5, px); }
	h2 + & { margin-top: unit(-@typo_h2_size * 0.4, px); }
	h3 + & { margin-top: unit(-@typo_h3_size * 0.3, px); }
	h4 + & { margin-top: unit(-@typo_h4_size * 0.1, px); }
	h5 + & { margin-top: unit(-@typo_h5_size * 0.1, px); }
	h6 + & { margin-top: unit(-@typo_h6_size * 0.1, px); }

	@media @tablet, @desktop {
		h1 + & { margin-top: unit(-@typo_h1_size * 0.8, px); }
		h2 + & { margin-top: unit(-@typo_h2_size * 0.7, px); }
		h3 + & { margin-top: unit(-@typo_h3_size * 0.6, px); }
		h4 + & { margin-top: unit(-@typo_h4_size * 0.2, px); }
		h5 + & { margin-top: unit(-@typo_h5_size * 0.2, px); }
		h6 + & { margin-top: unit(-@typo_h6_size * 0.2, px); }

		.hygge-sideblock h1 + & { margin-top: unit(-@typo_h1_size * 0.5, px); }
		.hygge-sideblock h2 + & { margin-top: unit(-@typo_h2_size * 0.4, px); }
		.hygge-sideblock h3 + & { margin-top: unit(-@typo_h3_size * 0.3, px); }
		.hygge-sideblock h4 + & { margin-top: unit(-@typo_h4_size * 0.1, px); }
		.hygge-sideblock h5 + & { margin-top: unit(-@typo_h5_size * 0.1, px); }
		.hygge-sideblock h6 + & { margin-top: unit(-@typo_h6_size * 0.1, px); }
	}

	.description-heading + & {
		margin-top: 0;
	}
}



.hygge-spacing {
	margin: 0;
	border: none;
}

.hygge-anchor {
	opacity: 0;
	margin: 0;
	border: none;
}



/* Headings
 *------------------------------------------------------------*/

h1,h2,h3,h4,h5,h6 {
	margin-top: 0;
	margin-bottom: 1em;

	&,
	& a {
		color: @black;
	}

	a:hover {
		text-decoration: none;
		color: @primary-color;
	}

	.dark-mode & {
		color: @white;
	}

	.label {
		margin-top: 1em;
		color: @grey;
	}
}

h1, .h1 {
	font-family: @typo_h1_font;
	font-weight: @typo_h1_weight;
	font-style: @typo_h1_style;
	font-size: unit(@typo_h1_size, px);
	line-height: @typo_h1_line;
	text-transform: @typo_h1_transform;
	letter-spacing: @typo_h1_letter;

	@media @mobile {
		font-size: unit(@typo_h1_size * 0.6, px);
	}
}

h2, .h2 {
	font-family: @typo_h2_font;
	font-size: unit(@typo_h2_size, px);
	font-weight: @typo_h2_weight;
	font-style: @typo_h2_style;
	line-height: @typo_h2_line;
	text-transform: @typo_h2_transform;
	letter-spacing: @typo_h2_letter;

	@media @mobile {
		font-size: unit(@typo_h2_size * 0.6, px);
	}
}

h3, .h3 {
	font-family: @typo_h3_font;
	font-size: unit(@typo_h3_size, px);
	font-weight: @typo_h3_weight;
	font-style: @typo_h3_style;
	line-height: @typo_h3_line;
	text-transform: @typo_h3_transform;
	letter-spacing: @typo_h3_letter;

	@media @mobile {
		font-size: unit(@typo_h3_size * 0.6, px);
	}
}

h4, .h4  {
	font-family: @typo_h4_font;
	font-size: unit(@typo_h4_size, px);
	font-weight: @typo_h4_weight;
	font-style: @typo_h4_style;
	line-height: @typo_h4_line;
	text-transform: @typo_h4_transform;
	letter-spacing: @typo_h4_letter;

	@media @mobile {
		font-size: unit(@typo_h4_size * 0.7, px);
	}
}

h5, .h5  {
	font-family: @typo_h5_font;
	font-size: unit(@typo_h5_size, px);
	font-weight: @typo_h5_weight;
	font-style: @typo_h5_style;
	line-height: @typo_h5_line;
	text-transform: @typo_h5_transform;
	letter-spacing: @typo_h5_letter;
}

h6, .h6  {
	font-family: @typo_h6_font;
	font-size: unit(@typo_h6_size, px);
	font-weight: @typo_h6_weight;
	font-style: @typo_h6_style;
	line-height: @typo_h6_line;
	text-transform: @typo_h6_transform;
	letter-spacing: @typo_h6_letter;
}

.font--navigation {
	font-family: @typo_navigation_font;
	font-size: unit(@typo_navigation_size, px);
	font-weight: @typo_navigation_weight;
	font-style: @typo_navigation_style;
	line-height: @typo_navigation_line;
	text-transform: @typo_navigation_transform;
	letter-spacing: @typo_navigation_letter;
}

.label {
	font-family: @typo_label_font;
	font-size: unit(@typo_label_size, px);
	font-weight: @typo_label_weight;
	font-style: @typo_label_style;
	line-height: @typo_label_line;
	text-transform: @typo_label_transform;
	letter-spacing: @typo_label_letter;
}

.label--italic {
	font-family: @typo_label_italic_font;
	font-weight: @typo_label_italic_weight;
	font-size: unit( @typo_label_italic_size, px);
	font-style: @typo_label_italic_style;
	line-height: @typo_label_italic_line;
	text-transform: @typo_label_italic_transform;
	letter-spacing: @typo_label_italic_letter;
	color: @grey-label;

	.dark-mode & { color: @white; }
	.grey-mode & { color: @grey; }
}

.description-heading {
	font-family: @typo_description_font;
	font-size: unit(@typo_description_size, px);
	font-weight: @typo_description_weight;
	font-style: @typo_description_style;
	line-height: @typo_description_line;
	text-transform: @typo_description_transform;
	letter-spacing: @typo_description_letter;

	.editor-content & {
		color: @black;
	}

	@media @mobile {
		font-size: unit(@typo_description_size * 0.7, px);
	}
}

.highlighted-p {
	.description-heading;
}



/* Lists
 *------------------------------------------------------------*/

.post__content {

	ol, ul {
		list-style: none;
		padding-left: 0px;
		overflow: hidden;

		@media @mobile { padding-left: 5px; }

		li {
			position: relative;
			padding: 0.6em 0 0.6em 0px;
			margin-left: 30px;

			&:last-child {padding-bottom: 0;}

			&:before {
				left: -25px;
				display: inline-block;
				position: absolute;
				line-height: 0 !important;
			}

			// Sublevels
			ol, ul {
				margin: 0.4em 0 -0.4em 0px;

				li {
					margin-left: 0px;
					padding-left: 30px;
				}
			}

			// Sublevel ol
			ol {
				li:before {
					left: 5px;
				}
			}

			// Sublevel ul
			ul {
				li:before,
				li:after {
					left: 5px;
				}
			}
		}
	}

	ol {
		counter-reset: item;

		& > li:before {
			content: counter(item)'.';
			.label;
			color: @black;
			counter-increment: item;
			top: 2.1em;
		}
	}

	ul {
		& > li:before {
			content: '\002022';
			font-size: 1.5em;
			top: 1em;
		}
	}

	.hygge-sideblock {
		ol, ul {
			ol, ul {
				li {
					padding-left: 25px;
					margin-left: 0;

					&:before,
					&:after {
						left: 0px;
					}
				}
			}
		}
	}
}



/* Caption Image
 *------------------------------------------------------------*/

.wp-caption {
	.clearfix;
	position: relative;
	z-index: 1;
	background: none;
	border: none;
	max-width: 100%;
	padding: 0;
	text-align: left;
	word-wrap: normal;
	overflow-wrap: normal;

	img {
		margin-bottom: 0 !important;
		margin-top: 0 !important;
	}
}

.wp-caption-text,
.gallery-caption {
	position: absolute;
	z-index: 1;
	bottom: 0;
	left: 0;
	max-width: 75%;
	overflow: hidden;
	.label;
	padding: 10px 15px;
	background: @grey-pale;
	color: @black;
	.transition;
	white-space: normal;

	.gallery--masonry & {
		bottom: 4px;
		left: 4px;
	}
}



/* Dropcap
 *------------------------------------------------------------*/

.dropcap {
	z-index: -1;
	color: @black;
	margin-left: -5px;
	font-family: @typo_h1_font;
	font-size: unit((@typo_h1_size), px);
	font-weight: bold;
	float: left;
	width: 105px;
	height: 80px;
	line-height: 100px;
	text-align: center;

	i {
		font-size: 0.8em;
		line-height: inherit;
	}

	.hygge-sideblock & {
		line-height: 0.75;
		width: 30px;
	}
}



/* Blockquote
 *------------------------------------------------------------*/

blockquote {
	position: relative;
	z-index: 1;
	padding: 0px 30px;
	margin-left: auto;
	margin-right: auto;
	font-family: @typo_blockquote_font;
	font-size: unit(@typo_blockquote_size, px);
	font-weight: @typo_blockquote_weight;
	font-style: @typo_blockquote_style;
	line-height: @typo_blockquote_line;
	text-transform: @typo_blockquote_transform;
	letter-spacing: @typo_blockquote_letter;

	&:before {
		content: '\201C';
		.label--italic;
		font-size: 70px;
		position: absolute;
		margin-left: -0.5em;
		margin-top: 0;
		line-height: 0.8;
		z-index: -1;
		opacity: 0.4;

		.dark-mode & {
			color: @white;
		}
	}

	p {
		margin-bottom: 0!important;
		display: block;

		&:last-child {
			margin-top: 0;
		}
	}

	.hygge-sideblock & {
		padding: 0 20px;
		text-align-last: left;
		margin-top: 0;
	}

	.dark-mode & {
		color: @white;
	}
}

cite {
	display: block;
	position: relative;
	.label;
	padding-top: 2.5em;
	text-align: left;

	a { color: inherit; }
}

.blockquote-wrapper {
	position: relative;
	background-color: @black;
	padding: 30px 10px;
	z-index: 1;
	color: @white;

	.img {
		.placement;
		background-position: 50% 50%;
		background-size: cover;
		opacity: 0.2;
		z-index: -1;
		filter: gray; /* IE 6-9 */
		-webkit-filter: grayscale(70%);
		filter: grayscale(70%);

		.color-opacity-low& {
			opacity: 0.5;
		}
	}

	blockquote {
		position: static;
		margin: 0;

		&:before {
			color: @white;
			opacity: 1;
		}
	}

	@media @tablet-h, @desktop {
		padding: 50px 35px;
	}
}



/* Rich Image
 *------------------------------------------------------------*/

.rich-image {
	position: relative;
	text-align: center;

	&__inwrap {
		position: relative;
		display: inline-block;
		text-align: left;
	}

	&__text {
		.clearfix;
		background: @grey-pale;
		padding: 30px;
		.small;
		line-height: 1.8;

		@media @tablet-h, @desktop {
			position: absolute;
			bottom: 0;
			left: 0;
			width: ~"calc( @{sideblock_width} + 50px )";
		}

		.description-heading {
			margin-bottom: 5px;
		}

		p {
			margin-bottom: 0;
		}
	}
}



/* Custom Banner
 *------------------------------------------------------------*/

.custom-banner {
	position: relative;

	.custom-banner__inwrap {
		display: block;
	}

	.custom-banner__text {
		background: @white;
		text-align: center;
		padding: 40px 0;
		.small;
		line-height: 1.7;

		&__inwrap {
			margin: auto;
			max-width: 550px;
			padding: 0 50px;

			& > * {
				margin-top: 0 !important;
				margin-bottom: 15px;

				&:last-child {
					margin-bottom: 0;
				}
			}

			.label--italic {
				color: @black;
			}
		}
	}

	@media @mobile, @tablet-v {
		img {
			height: auto !important;
		}
	}

	@media @desktop {
		background-size: cover;

		img { opacity: 0; }

		.custom-banner__text {
			position: absolute;
			top: 50%;
			left: 50%;
			.translate( -50%, -50% );
			width: 80%;
			max-width: 680px;
		}
	}

	@media @tablet-h {
		.hygge-sidebar--true & {
			img {
				height: auto !important;
			}
		}

		.hygge-sidebar--false & {
			background-size: cover;

			img { opacity: 0; }

			.custom-banner__text {
				position: absolute;
				top: 50%;
				left: 50%;
				.translate( -50%, -50% );
				width: 80%;
				max-width: 680px;
			}
		}
	}
}



/* Tables
 *------------------------------------------------------------*/

table {
	// table-layout: fixed;
	max-width: 100%;
	width: 100%;
	text-align: center;
	border-collapse: collapse;
	.label;

	.hygge-sideblock & {
		min-width: 100%;
		text-align: left;
	}

	td, th {
		padding: 1.5em 1em;
	}

	th,
	thead td {
		font-weight: inherit;
		color: @black;

		.dark-mode & {
			color: @white;
		}
	}

	thead {
		tr {
			& > * { border-bottom: 1px solid @grey-light; }
			&:not(:first-child) { border-top: 1px solid @grey-light; }

			.dark-mode & {
				& > * { border-color: @dark-border; }
				&:not(:first-child) { border-color: @dark-border; }
			}
		}
	}

	tbody,
	tfoot {
		.small;

		.dark-mode & {
			color: @white;
		}

		tr {

			& > * {
				border-top: 1px solid @grey-light;
				.dark-mode & { border-color: @dark-border; }
			}
			&:last-child {
				& > * {
					border-bottom: 1px solid @grey-light;
					.dark-mode & { border-color: @dark-border; }
				}
			}

			.transition( ~"all 0.25s cubic-bezier( 0.4, 0, 0.3, 1 )" );

			td {
				position: relative;

				// & + td {
				// 	border-left: 1px solid @grey-light;
				// 	.dark-mode & { border-left-color: @dark-border; }
				// }
			}
		}
	}

	thead ~ tbody tr:first-child { border-top: none; }
}



/* Code & Pre
 *------------------------------------------------------------*/

code, pre, kbd {
	font-family: Consolas,Monaco,'Andale Mono',monospace;
	font-size: 0.8em;
	display: inline-block;
	vertical-align: baseline;
	padding: 0 3px;
	background: @grey-pale;
	color: @black;
	word-wrap: break-word;
}

pre {
	width: 100%;
	padding: 30px;
	white-space: pre;
	white-space: pre-wrap;
	text-rendering: initial;
}



/* Wordpress core styles
 *------------------------------------------------------------*/

.alignnone,
.aligncenter,
.alignleft,
.alignright {
	display: block;
	margin-left: auto;
	margin-right: auto;
}

@media @tablet, @desktop {
	.alignleft 	{ float: left; margin-right: 30px; }
	.alignright { float: right; margin-left: 30px; }

	.alignleft, .alignright, .aligncenter { margin-top: 5px; }
}

@media @desktop {
	.alignleft 	{ margin-right: 45px; }
	.alignright { margin-left: 45px; }
}





/* Text only for screen readers
 *------------------------------------------------------------*/

.screen-reader-text {
	clip: rect(1px, 1px, 1px, 1px);
	position: absolute !important;
	height: 1px;
	width: 1px;
	overflow: hidden;
}

.screen-reader-text:focus {
	background-color: #f1f1f1;
	border-radius: 3px;
	box-shadow: 0 0 2px 2px rgba(0, 0, 0, 0.6);
	clip: auto !important;
	color: #21759b;
	display: block;
	font-size: 14px;
	font-size: 0.875rem;
	font-weight: bold;
	height: auto;
	left: 5px;
	line-height: normal;
	padding: 15px 23px 14px;
	text-decoration: none;
	top: 5px;
	width: auto;
	z-index: 100000; /* Above WP toolbar. */
}



/* Selection
 *------------------------------------------------------------*/

 ::selection {
	background:@primary-color;
	color:@white;
	text-shadow:none;
}
::-webkit-selection {
	background:@primary-color;
	color:@white;
	text-shadow:none;
}
::-moz-selection {
	background:@primary-color;
	color:@white;
	text-shadow:none;
}
